// Function to load css for select2
function loadCss(url, id) {
  if (!document.getElementById(id)) {
    var cssFile = document.createElement("link");
    cssFile.type = "text/css";
    cssFile.rel = "stylesheet";
    cssFile.id = id;
    cssFile.href = url;
    document.getElementsByTagName("head")[0].appendChild(cssFile);
  }
};

loadCss(Application.GlassContext.gateway + '/v1/ext/CogBox/js/libs/select2.css', 'select2css');
loadCss(Application.GlassContext.gateway + '/v1/ext/CogBox/js/libs/select2totree.css', 'select2totree');





define(
  ["jquery"
    , Application.GlassContext.gateway + '/v1/ext/CogBox/js/libs/select2_4.0.6-rc.1.js'
    , Application.GlassContext.gateway + '/v1/ext/CogBox/js/libs/select2totree.js'

  ]
  , function ($) {
    "use strict";

    function select2tree() {
    };


    select2tree.prototype.setData = function (oControlHost, oDataStore) {


      var
        groupBy = function (xs, key) {
          return xs.reduce(function (rv, x) {
            (rv[x[key]] = rv[x[key]] || []).push(x);
            return rv;
          }, {});
        }
        , och = oControlHost
        , o = och.configuration
        , ds = oDataStore
        , columnLen = ds.columnCount
        , myJSON = []
        , myObj = {}
        , hType = (o && o["hierarchyType"]) ? o["hierarchyType"] : 'PC'
        , recGroupFlat = function (r, lvl, maxLvl) {

          if (lvl > maxLvl) return true

          var jsonArr = []
            , obj = {}
            , keys
            , len
            ;

          obj = groupBy(r, lvl);
          keys = Object.keys(obj);
          len = keys.length;
          //console.log('lvl: ' + lvl + ' len: ' + len);

          for (var i = 0; i < len; ++i) {
            var json = {};
            //console.log('lvl: ' + lvl + ' i: '+i +': '+ ds.columnValues[lvl][keys[i]] +' - ' +ds.columnValues[lvl+1][keys[i]]);
            json.id = ds.columnValues[lvl + 1][keys[i]];
            json.value = ds.columnValues[lvl + 1][keys[i]];
            json.text = ds.columnValues[lvl][keys[i]];
            if (lvl + 2 < maxLvl) json.inc = recGroupFlat(obj[keys[i]], lvl + 2, maxLvl);
            jsonArr.push(json);
          }

          return jsonArr
        }
        , recGroupPC = function (oldArr) {
          var map = {}
            , newArr = [];
          for (var i = 0; i < oldArr.length; i++) {
            var obj = {};
            obj.text = ds.columnValues[0][oldArr[i][0]];
            obj.id = ds.columnValues[1][oldArr[i][1]];
            obj.value = ds.columnValues[1][oldArr[i][1]];
            obj.parent = ds.columnValues[2][oldArr[i][2]];
            newArr.push(obj);
          }

          for (var i = 0; i < newArr.length; i++) {
            var obj = newArr[i]

            if (!(obj.id in map)) {
              map[obj.id] = obj;
            }
            if (typeof map[obj.id].text == 'undefined') {
              map[obj.id].id = obj.id;
              map[obj.id].text = obj.text;
              map[obj.id].parent = obj.parent;
            }

            var parent = obj.parent || '-';
            if (!(parent in map)) {
              map[parent] = {};
            }

            if (!map[parent].inc) map[parent].inc = [];
            map[parent].inc.push(map[obj.id])
          }
          if (!map['-']) {
            var newMap = [];
            $.each(map, function (index, value) {
              if (value.inc && !value.text) { newMap.push(value) }
            }

            )
            return newMap[0].inc;
          }
          else { return map['-'].inc }
        }


        ;

      if (hType == 'flat') this.data = recGroup(ds.json.rows, 0, columnLen);
      if (hType == 'PC') this.data = recGroupPC(ds.json.rows);
    };


    select2tree.prototype.draw = function (oControlHost) {

      var och = oControlHost
        , o = och.configuration
        , elm = och.container
        , sel = document.createElement('select')
        , param = (o && o["prompt"]) ? o["prompt"] : 'Parameter1'
        , ctrl = oControlHost.page.getControlByName(param)
        , preselectedVals = []
        , vals = []
        , data = this.data
        , updated = this.updated
        , selVals = ctrl.getValues()
        , placeholder = (o && o["placeholder"]) ? o["placeholder"] : ""
        ;



      this.sel = sel;
      elm.appendChild(sel);
      $(sel).select2ToTree({ treeData: { dataArr: data }, allowClear: false, closeOnSelect: false, multiple: true, placeholder: placeholder })
        .on('select2:select', function () { updated(och) })
        .on('select2:unselect', function () { updated(och) })

        /*this is tricky. We need to catch an unselect attempt, test if it's a non-ctrl click, 
         * if it is a ctrl click, allow unselect
         * if it is not a ctrl click, keep this value selected and clear the others. 
         */
        .on('select2:unselecting', function () {
          if (window.event && !window.event.ctrlKey && window.event.currentTarget.tagName == 'UL') { $(this).val(null); $(this).select2('close') }
        })
        .on('select2:selecting', function () {
          if (window.event && !window.event.ctrlKey) { $(this).val(null); $(this).select2('close') }
        })
        ;


      for (var i = 0; i < selVals.length; ++i) {
        vals.push(selVals[i].use);
      }
      $(sel).val(vals);
      $(sel).trigger('change');
      updated(och);

      /*
  {"parameter":"Parameter1","values":[{"use":"992","display":"Mountaineering Equipment"},{"use":"993","display":"Personal Accessories"},{"use":"994","display":"Outdoor Protection"}]}
  */
    };

    select2tree.prototype.updated = function (oControlHost) {
      var och = oControlHost
        , o = och.configuration
        , valLen, paramJSON = [];

      oControlHost.valueChanged();
      if (window.event && !window.event.ctrlKey && window.event.currentTarget.tagName == 'UL') {

        oControlHost.next()
      };


      if ((o && o["autoSubmit"])) {
        oControlHost.next();
      }


      //oControlHost.container.dataset.parameters = encodeURIComponent(JSON.stringify( {"name": param,"value": paramJSON	}    ));




    };

    select2tree.prototype.getParameters = function (oControlHost) {

      var
        och = oControlHost
        , o = och.configuration
        , param = (o && o["prompt"]) ? o["prompt"] : 'Parameter1'
        , json = $(this.sel).select2('data')
        , paramJSON = []
        ;


      /* results look like:
      [{"selected":true,"disabled":false,"text":"Camping Equipment","id":"991","title":"","_resultId":"select2-v4-result-b2gw-991","element":{}}
      ,{"selected":true,"disabled":false,"text":"Outdoor Protection","id":"994","title":"","_resultId":"select2-v4-result-hp3m-994","element":{}}
      ,{"selected":true,"disabled":false,"text":"Golf Equipment","id":"995","title":"","_resultId":"select2-v4-result-j2di-995","element":{}}]
      */

      for (var i = 0; i < json.length; ++i) {
        paramJSON.push({ 'use': json[i].id, 'display': json[i].text })
      };

      och.page.getControlByName(param).setValues(paramJSON);
    };

    return select2tree;
  });